<template>
  <a-modal
    :title="title"
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :confirmLoading="confirmLoading"
    @ok="handleOk"
    @cancel="handleCancel"
    cancelText="关闭">

    <a-spin :spinning="confirmLoading">
      <a-form-model ref="form" :model="model" :rules="validatorRules">

        <a-form-model-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          prop="code"
          required
          label="资料袋编码">
          <a-input placeholder="请输入资料袋编码" v-model="model.code" :read-only="readOnly"/>
        </a-form-model-item>
        <a-form-model-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          prop="type"
          label="资料袋类型">
          <a-input placeholder="请输入资料袋类型" v-model="model.type"/>
        </a-form-model-item>
        <a-form-model-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          prop="site"
          label="所属站点">
          <a-input placeholder="请输入所属站点" v-model="model.site"/>
        </a-form-model-item>
        <a-form-model-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          prop="relatedEquipment"
          label="关联设备">
          <a-input placeholder="请输入关联设备" v-model="model.relatedEquipment"/>
        </a-form-model-item>
        <a-form-model-item
          :labelCol="labelCol"
          :wrapperCol="wrapperCol"
          prop="relatedEquipment"
          label="资料袋二维码">
          <div style="display: flex; align-items: center;">
            <!-- <j-image-upload text="" v-model="model.bagQrCode"></j-image-upload> -->
            <div id="getQrCode" style="margin-left: 1%;height:100px"></div>
            <a-button :disabled="model.code == null || model.code == ''" @click="refreshQrCode" type="primary" style="left: 30px;">生成二维码</a-button>
          </div>
        </a-form-model-item>

      </a-form-model>
    </a-spin>
  </a-modal>
</template>

<script>
  import pick from 'lodash.pick'
  import { httpAction } from '@/api/manage'
  import { duplicateCheck } from '@/api/api'
  import JDictSelectTag from '@/components/dict/JDictSelectTag'
  import QRCode from 'qrcodejs2';

  let validatorCodeTimer = null

  export default {
    name: 'SysPositionModal',
    components: { JDictSelectTag },
    data() {
      return {
        title: '操作',
        visible: false,
        model: {},
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        confirmLoading: false,
        validatorRules: {
          code: [
              { required: true, message: '请输入资料袋编码' },
              {
                validator: (rule, value, callback) => {
                  // 函数消抖的简单实现，防止一段时间内发送多次请求
                  if (validatorCodeTimer) {
                    // 停止上次开启的定时器
                    clearTimeout(validatorCodeTimer)
                  }
                  validatorCodeTimer = setTimeout(() => {
                    duplicateCheck({
                      tableName: 'sys_position',
                      fieldName: 'code',
                      fieldVal: value,
                      dataId: this.model.id
                    }).then((res) => {
                      if (res.success) {
                        callback()
                      } else {
                        callback(res.message)
                      }
                    }).catch(console.error)
                  }, 300)
                }
              }
            ],
        },
        url: {
          add: '/system/materialBag/add',
          edit: '/sys/position/edit',
        },
        readOnly:false
      }
    },
    created() {
    },
    methods: {
          refreshQrCode() {
          this.$nextTick(function () {
            document.getElementById("getQrCode").innerHTML = "";
            const  qrCodeUrl1 = new QRCode("getQrCode", {
              width: 100,
              height: 100,
              text: this.model.code,
              colorDark: "#000000",
              colorLight: "#ffffff",
            });
            const divElement = document.getElementById('getQrCode');

              // 在 div 元素下找到 img 元素
              const imgElement = divElement.querySelector('img');

              // 获取 img 元素的 src 属性
              imgElement.onload = function() {
                console.log(imgElement.src);
              };

              imgElement.src = imgElement.src; // 触发加载

          });
      },
      add() {
        this.edit({})
      },
      edit(record) {
        this.model = Object.assign({}, record)
        this.visible = true
        if(record.id){
          this.readOnly=true
        }else{
          this.readOnly=false
        }
      },
      close() {
        document.getElementById("getQrCode").innerHTML = "";
        this.$emit('close')
        this.visible = false
        this.$refs.form.resetFields();
      },
      handleOk() {
        const that = this
        // 触发表单验证
        this.$refs.form.validate(valid => {
          if (valid) {
            that.confirmLoading = true
            let httpurl = ''
            let method = ''
            if (!this.model.id) {
              httpurl += this.url.add
              method = 'post'
            } else {
              httpurl += this.url.edit
              method = 'put'
            }

            httpAction(httpurl, this.model, method).then((res) => {
              if (res.success) {
                that.$message.success(res.message)
                that.$emit('ok')
              } else {
                that.$message.warning(res.message)
              }
            }).finally(() => {
              that.confirmLoading = false
              that.close()
            })
          }else{
            return false;
          }
        })
      },
      handleCancel() {
        this.close()
      },


    }
  }
</script>

<style lang="less" scoped>
.ant-modal-footer  {
     text-align: center !important;
}
.ant-modal-confirm .ant-modal-confirm-btns {
  text-align: center !important;
}

div.ant-modal-footer {
  text-align: center !important;
}
</style>
